<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.5"/>
<title>fwConfigurationDB: Private Functions</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">fwConfigurationDB
   &#160;<span id="projectnumber">8.4.1</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.5 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('group__PrivateFunctions.html','');});
</script>
<div id="doc-content">
<div class="header">
  <div class="headertitle">
<div class="title">Private Functions</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="member-group"></a>
Private Functions in general module</h2></td></tr>
<tr class="memitem:ga3aa0e1a7d29928aaf3ce7a2365617504"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__PrivateFunctions.html#ga3aa0e1a7d29928aaf3ce7a2365617504">_fwConfigurationDB_getPropertiesAndDPEs</a> (string dptName, dyn_string &amp;properties, dyn_string &amp;dpes, string &amp;devTypeName, dyn_string &amp;exceptionInfo, string deviceModel=&quot;&quot;)</td></tr>
<tr class="separator:ga3aa0e1a7d29928aaf3ce7a2365617504"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga0d676d6dd6d248a1db7f00b75ebbd084"><td class="memItemLeft" align="right" valign="top">dyn_string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__PrivateFunctions.html#ga0d676d6dd6d248a1db7f00b75ebbd084">_fwConfigurationDB_getDPTElements</a> (string dptName, dyn_string &amp;exceptionInfo, bool all=FALSE)</td></tr>
<tr class="separator:ga0d676d6dd6d248a1db7f00b75ebbd084"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga9b613877e2156e94cb06da25c1aaf91f"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__PrivateFunctions.html#ga9b613877e2156e94cb06da25c1aaf91f">_fwConfigurationDB_getDPTElements2</a> (string dptName, dyn_string &amp;elementNames, dyn_int &amp;elementTypes, dyn_string &amp;exceptionInfo, bool all=FALSE)</td></tr>
<tr class="separator:ga9b613877e2156e94cb06da25c1aaf91f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga6a9645cfe3f824ba48530ee16525c73d"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ga6a9645cfe3f824ba48530ee16525c73d"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><b>_fwConfigurationDB_typeIdToDpeTypeId</b> (int varType)</td></tr>
<tr class="separator:ga6a9645cfe3f824ba48530ee16525c73d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga35869423f789ddfd0bc8f2e98da9ebd6"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ga35869423f789ddfd0bc8f2e98da9ebd6"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>_fwConfigurationDB_dataToString</b> (anytype data, int dataType, string listSeparator, string &amp;encodedData, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:ga35869423f789ddfd0bc8f2e98da9ebd6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga942e37307de96357e2613a8d290196f7"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ga942e37307de96357e2613a8d290196f7"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>_fwConfigurationDB_stringToData</b> (string encodedData, int dataType, string listSeparator, anytype &amp;data, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:ga942e37307de96357e2613a8d290196f7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gabd802c25643acf745a44a1ae1c203b52"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="gabd802c25643acf745a44a1ae1c203b52"></a>
string&#160;</td><td class="memItemRight" valign="bottom"><b>_fwConfigurationDB_getFwDeviceName</b> (string dptName, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:gabd802c25643acf745a44a1ae1c203b52"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga1ac12bb504fda040005b46408e76df9e"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__PrivateFunctions.html#ga1ac12bb504fda040005b46408e76df9e">_fwConfigurationDB_getAlertData</a> (dyn_dyn_mixed &amp;recipeObject, int row, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:ga1ac12bb504fda040005b46408e76df9e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gabccfe0eff7a96ef3059ecf134edc5e85"><td class="memItemLeft" align="right" valign="top">string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__PrivateFunctions.html#gabccfe0eff7a96ef3059ecf134edc5e85">_fwConfigurationDB_NodeSystemName</a> (string nodeName)</td></tr>
<tr class="separator:gabccfe0eff7a96ef3059ecf134edc5e85"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga82e90231e92e5a051f062fae12c9eb02"><td class="memItemLeft" align="right" valign="top">string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__PrivateFunctions.html#ga82e90231e92e5a051f062fae12c9eb02">_fwConfigurationDB_NodeNameWithoutSystem</a> (string nodeName)</td></tr>
<tr class="separator:ga82e90231e92e5a051f062fae12c9eb02"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gab83ba42c5efac0f55782a8a11a05fb7e"><td class="memItemLeft" align="right" valign="top">string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__PrivateFunctions.html#gab83ba42c5efac0f55782a8a11a05fb7e">_fwConfigurationDB_NodeNameWithSystem</a> (string nodeName, string systemName, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:gab83ba42c5efac0f55782a8a11a05fb7e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gabbf30e85bbbb5342e767d3f55929c1a5"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="gabbf30e85bbbb5342e767d3f55929c1a5"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>fwConfigurationDB_dpSetMany</b> (dyn_string &amp;dpes, dyn_mixed &amp;values, dyn_string &amp;exceptionInfo, string systemName=&quot;&quot;)</td></tr>
<tr class="separator:gabbf30e85bbbb5342e767d3f55929c1a5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gafcf37f2ea3a3dd622525d6aef5196815"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__PrivateFunctions.html#gafcf37f2ea3a3dd622525d6aef5196815">fwConfigurationDB_dpSetManyDist</a> (dyn_string &amp;dpes, dyn_mixed &amp;values, dyn_string &amp;exceptionInfo, bool checkDpeExist=false)</td></tr>
<tr class="separator:gafcf37f2ea3a3dd622525d6aef5196815"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<h2 class="groupheader">Function Documentation</h2>
<a class="anchor" id="ga3aa0e1a7d29928aaf3ce7a2365617504"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void _fwConfigurationDB_getPropertiesAndDPEs </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>dptName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>properties</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>dpes</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string &amp;&#160;</td>
          <td class="paramname"><em>devTypeName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>deviceModel</em> = <code>&quot;&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">Retrieves dp elements for a dp type
</pre><p>This function retrieves the list of data point elements for a given data poin type. If the dpt is a framework data point type, the appropriate device definition is queried to determine the names related to data point elements.</p>
<p>On return, for the Framework Device data point types, the first list (properties variable) will contain the list of property names present in the device definition. The second list (dpes variable) will contain the data point element names associated with the property names from the first list, plus all the data point elements that have no device definition. This way, the function may be used to get the list of all dpes (the second list), the list of dpes from the device definitions (take only the first N items from the second list, where N is the number of elements of the first list), etc. The function will also return the device name from the device definition (in the devName argument).</p>
<p>For non-Frame Device data point types, the first list will always be empty, and the second list will contain the list of all dpes.</p>
<p>Note, that this function will work even if there is no instance of a device type available yet! (In such a case, extracting all data point element could have been done simply by a combination of dpNames() and dpSubStr() for an arbitrary, existing data point...</p>
<p>See also <a class="el" href="group__PrivateFunctions.html#ga0d676d6dd6d248a1db7f00b75ebbd084">_fwConfigurationDB_getDPTElements</a> .</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">dptName</td><td>the name of data point type </td></tr>
    <tr><td class="paramname">properties</td><td>on return will contain the list of property names </td></tr>
    <tr><td class="paramname">dpes</td><td>on return will contain the list of all data point elements </td></tr>
    <tr><td class="paramname">devTypeName</td><td>on return will contain the device type name from the device definition, or dptName </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>standard exception handling variable </td></tr>
    <tr><td class="paramname">deviceModel</td><td>(optional) device model </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ga0d676d6dd6d248a1db7f00b75ebbd084"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">dyn_string _fwConfigurationDB_getDPTElements </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>dptName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>all</em> = <code>FALSE</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">Retrieves the names of DP elements for given data point type
</pre><p>This function retrieves all data point elements for specified data point type. resolving (recursively) all references to other data points and structures.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">dptName</td><td>the name of the data point type </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>standard exception handling variable </td></tr>
    <tr><td class="paramname">all</td><td>(optional) if TRUE, all properties, including the "." entries of structures will be resolved; If FALSE, only the leaves of the structures will be returned </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the list of all data point elements for dptName</dd></dl>
<dl class="section see"><dt>See Also</dt><dd><a class="el" href="group__PrivateFunctions.html#ga9b613877e2156e94cb06da25c1aaf91f">_fwConfigurationDB_getDPTElements2</a> </dd></dl>

</div>
</div>
<a class="anchor" id="ga9b613877e2156e94cb06da25c1aaf91f"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void _fwConfigurationDB_getDPTElements2 </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>dptName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>elementNames</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_int &amp;&#160;</td>
          <td class="paramname"><em>elementTypes</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>all</em> = <code>FALSE</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">Retrieves the names and types of DP elements for given data point type
</pre><p>This function retrieves all data point elements for specified data point type. resolving (recursively) all references to other data points and structures.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">dptName</td><td>the name of the data point type </td></tr>
    <tr><td class="paramname">elementNames</td><td>on return will contain the names of dp elements </td></tr>
    <tr><td class="paramname">elementTypes</td><td>on return will contain the types of dp elements </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>standard exception handling variable </td></tr>
    <tr><td class="paramname">all</td><td>(optional) if TRUE, all properties, including the "." entries of structures will be resolved; If FALSE, only the leaves of the structures will be returned</td></tr>
  </table>
  </dd>
</dl>
<dl class="section see"><dt>See Also</dt><dd>fwConfigurationDB_getDPTElements </dd></dl>

</div>
</div>
<a class="anchor" id="ga1ac12bb504fda040005b46408e76df9e"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void _fwConfigurationDB_getAlertData </td>
          <td>(</td>
          <td class="paramtype">dyn_dyn_mixed &amp;&#160;</td>
          <td class="paramname"><em>recipeObject</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>row</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">Gets the alert settings
</pre><p>This function gets current alert settings for a dp from the system and stores it in the data structure which is a single row of <a class="el" href="index.html#recipeObject">recipeObject</a>. The data point name and data point element are passed in thr recipeRow variable as well.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">recipeRow</td><td>the input/output variable, a single row of the recipeObject refering to a single DPE. <ul>
<li>on entry, recipeRow[fwConfigurationDB_RO_DP_NAME] should contain the datapoint name, and recipeRow[fwConfigurationDB_RO_ELEMENT_NAME] the data point element </li>
<li>on exit, the entries that refer to alerts will be filled with data (indices fwConfigurationDB_RO_HAS_ALERT, and fwConfigurationDB_RO_ALERT_MINIDX to fwConfigurationDB_RO_ALERT_MINIDX), the other will not be touched </li>
</ul>
</td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>standard exception handling variable </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="gabccfe0eff7a96ef3059ecf134edc5e85"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">string _fwConfigurationDB_NodeSystemName </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>nodeName</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Returns system name of the node. If not specified in nodeName, returns local system </p>

</div>
</div>
<a class="anchor" id="ga82e90231e92e5a051f062fae12c9eb02"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">string _fwConfigurationDB_NodeNameWithoutSystem </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>nodeName</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Returns the device (node) name, ensuring it does not contain system name </p>

</div>
</div>
<a class="anchor" id="gab83ba42c5efac0f55782a8a11a05fb7e"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">string _fwConfigurationDB_NodeNameWithSystem </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>nodeName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>systemName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">Returns the device (node) name, ensuring it has system name in it.
</pre><p>passing "" as systemName means: use local system. </p>

</div>
</div>
<a class="anchor" id="gafcf37f2ea3a3dd622525d6aef5196815"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwConfigurationDB_dpSetManyDist </td>
          <td>(</td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>dpes</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_mixed &amp;&#160;</td>
          <td class="paramname"><em>values</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>checkDpeExist</em> = <code>false</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">performs a dpSet for a list of datapoint elements
</pre><p>the list may contain dpes for many systems - they are sorted/grouped appropriately</p>
<p>The parameters: dpes and values are passed by reference to avoid re-allocation; they are not modified </p>

</div>
</div>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.5 </li>
  </ul>
</div>
</body>
</html>
